
// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2005                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************

// -------------------------------------------------------------------
// FVX Sample Program
// 
//
// 쐬 : D.Yamaguchi
//    : 2005/11/25 
//
//-------------------------------------------------------------------

// xyangleDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "xyangle.h"
#include "xyangleDlg.h"
#include "LicenseDlg.h"
#include "ConfFileDlg.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

namespace
{
	const double PI = 3.14159265358979;
}

extern CXyangleApp theApp;

/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CXyangleDlg _CAO

CXyangleDlg::CXyangleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CXyangleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CXyangleDlg)
	m_WindowTouch = FALSE;
	m_Condition = 5;
	m_ScoreThresh = 60;
	m_ScoreThresh2 = 50;
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CXyangleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CXyangleDlg)
	DDX_Control(pDX, IDC_RESULT, m_Result);
	DDX_Control(pDX, IDC_SEARCHMODE, m_SearchMode);
	DDX_Control(pDX, IDC_PRECISION, m_Precision);
	DDX_Check(pDX, IDC_WINDOWTOUCH, m_WindowTouch);
	DDX_Text(pDX, IDC_CONDITION, m_Condition);
	DDX_Text(pDX, IDC_SCORETHRESH, m_ScoreThresh);
	DDX_Text(pDX, IDC_SCORETHRESH2, m_ScoreThresh2);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CXyangleDlg, CDialog)
	//{{AFX_MSG_MAP(CXyangleDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_SETSTANDARD, OnSetStandard)
	ON_BN_CLICKED(IDC_EXECUTE, OnExecute)
	ON_BN_CLICKED(IDC_EXEREGION, OnExeRegion)
	ON_BN_CLICKED(IDC_SETPATTERN_1, OnSetpattern1)
	ON_BN_CLICKED(IDC_SETMASK_1, OnSetmask1)
	ON_BN_CLICKED(IDC_DISPPATTERN_1, OnDisppattern1)
	ON_BN_CLICKED(IDC_LOADPATTERN_1, OnLoadpattern1)
	ON_BN_CLICKED(IDC_SAVEPATTERN_1, OnSavepattern1)
	ON_BN_CLICKED(IDC_SETPATTERN_2, OnSetpattern2)
	ON_BN_CLICKED(IDC_SETMASK_2, OnSetmask2)
	ON_BN_CLICKED(IDC_DISPPATTERN_2, OnDisppattern2)
	ON_BN_CLICKED(IDC_LOADPATTERN_2, OnLoadpattern2)
	ON_BN_CLICKED(IDC_SAVEPATTERN_2, OnSavepattern2)
	ON_BN_CLICKED(IDC_LOADIMAGE, OnLoadImage)
	ON_BN_CLICKED(IDC_SAVEIMAGE, OnSaveImage)
	ON_BN_CLICKED(IDC_DOSAMPLE, OnDoSample)
	ON_BN_CLICKED(IDC_GRAB, OnGrab)
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CXyangleDlg bZ[W nh

BOOL CXyangleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB
	
	CString strErr;

	// COM
	CoInitialize( NULL );
	CWnd *pWnd, *pWndGrabButton;
	IUnknown *p_Unknown;

	// Dialogɓ\tFvxDisplayRg[̎̂擾
	pWnd = this->GetDlgItem( IDC_FVXDISPLAYEX1 );
	p_Unknown = pWnd->GetControlUnknown();
	p_Unknown->QueryInterface( __uuidof( IFvxDisplayEx2Ptr ), (void**)&m_FvxDisplayEx );

	// Rg[̃CX^X̐
	m_FvxVideo.CreateInstance( __uuidof( FvxVideo ) );
	m_FvxROI.CreateInstance( __uuidof( FvxROI ) );
	m_FvxPerformanceCounter.CreateInstance( __uuidof( FvxPerformanceCounter ) );
	m_FvxPattern.CreateInstance( __uuidof( FvxPattern ) );
	m_FvxPattern2.CreateInstance( __uuidof( FvxPattern ) );
	m_FvxImage.CreateInstance( __uuidof( FvxImage ) );
	m_FvxFileAccess.CreateInstance( __uuidof( FvxFileAccess ) );
	m_FvxCorrelation.CreateInstance( __uuidof( FvxCorrelation ) );
	m_FvxCalcData.CreateInstance( __uuidof( FvxCalcData ) );
	m_FvxPaintOnImage.CreateInstance( __uuidof( FvxPaintOnImage ) );
	m_ExeRegion.CreateInstance( __uuidof( FvRectangle ) );
	m_StandardPoint.CreateInstance( __uuidof( FvPoint ) );
	
	// ݒpRg[̏
	m_SearchMode.AddString( "ʏ̃p^[" );
	m_SearchMode.AddString( "̃p^[" );
	m_SearchMode.AddString( "̃p^[" );
	m_SearchMode.AddString( "sp^[" );
	m_SearchMode.SetCurSel( 0 );

	m_Precision.AddString( "ʏ퐸x" );
	m_Precision.AddString( "x" );
	m_Precision.AddString( "x" );
	m_Precision.SetCurSel( 0 );

	m_blnVideoOpened = FALSE;
	pWndGrabButton = this->GetDlgItem( IDC_GRAB );
	pWndGrabButton->EnableWindow( FALSE );

	CLicenseDlg ldlg;
	CConfFileDlg fdlg;

	// gp̊mF
	if( IDOK == ldlg.DoModal() )
	{
		// rfIݒt@C̑I
		fdlg.DoModal();

		if( FALSE == fdlg.m_check )
		{
			try
			{
				// rfIݒt@CR|[lgɐݒ
				m_FvxVideo->PutVideoConfFile( (_bstr_t)fdlg.m_conffile );

				// rfIfoCXI[v
				m_FvxVideo->OpenDevice();
				m_blnVideoOpened = TRUE;

				// VideoConfFile̕ύXAOpenDevicesƁAgK[[h̕ύX܂
				// ̂߁AЃLv`{[hFVC02ł350ms̃ZbgAbv^CKvɂȂ܂
				// {vOł͊ȗ̂߂ɁAꗥ350ms̃ZbgAbv^CmۂĂ܂A
				// g̃Lv`{[hɍ킹ĕύXĂB
				::Sleep( 350 );

				// GrabSync/GrabASync\bhłImageTCY̕ύXs܂̂ŁA
				// 炩ChangeImageSize\bhɂImagẽTCYύXĂ
				//i荞݃TCYImagẽTCYႤꍇG[ɂȂ܂j
				m_FvxVideo->ChangeImageSize( m_FvxImage );

				try
				{
					// 捞
					m_FvxVideo->GrabSync( m_FvxImage );
					pWndGrabButton->EnableWindow( TRUE );
				}
				catch( _com_error )
				{
					strErr.Format( "rfI̎荞݂Ɏs܂\n摜t@Ĉ݂̗pɂȂ܂B" );
					::AfxMessageBox( strErr, MB_ICONWARNING | MB_OK );
				}
			}
			catch( _com_error )
			{
				strErr.Format( "rfIfoCX̃I[vɎs܂\n摜t@Ĉ݂̗pɂȂ܂B" );
				::AfxMessageBox( strErr, MB_ICONWARNING | MB_OK );
			}
		}
	}
	else
	{
		// ӂĂ炦Ȃ瑦I
		this->EndDialog( IDCANCEL );
	}

	// ʂ̐
	m_FvxDisplayEx->CreateDisplay( 1, 0 );

	// 摜̕\
	m_FvxDisplayEx->DrawImage( m_FvxImage );

	// ͈͂̏lݒ(摜̑Sʂɐݒj
	m_ExeRegion->Putxs( -1 );
	m_ExeRegion->Putys( -1 );
	m_ExeRegion->Putxe( -1 );
	m_ExeRegion->Putye( -1 );




	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

void CXyangleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CXyangleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CXyangleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CXyangleDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	
	// rfIfoCXI[vĂꍇ̓N[Y܂
	if( TRUE == m_blnVideoOpened )
	{
		m_FvxVideo->CloseDevice();
	}

}

int CXyangleDlg::ApplyChanges()
{
	int iStatus = -1;

	// DDX͈̓`FbN
	if( 0 == this->UpdateData( TRUE ) ) return iStatus;

	// p[^ݒ
	m_FvxCorrelation->SetInspectArea( m_ExeRegion );// ͈
	m_FvxCorrelation->PutSearchMode( static_cast<FVXCOMLib::SEARCH_MODE_TYPE>( m_SearchMode.GetCurSel() ) );// T[`[h
	m_FvxCorrelation->PutPrecision( static_cast<FVXCOMLib::PRECISION_TYPE>( m_Precision.GetCurSel() ) );// T[`
	m_FvxCorrelation->PutScoreThresh( m_ScoreThresh );
	m_FvxCorrelation->PutScoreThresh2( m_ScoreThresh2 );
	m_FvxCorrelation->PutCondition( m_Condition );


	// T[`
	m_FvxCorrelation->PutSearchNum( 1 );

	// ͈͐ڐGĂ̂o邩
	if( TRUE == CXyangleDlg::m_WindowTouch )
	{
		m_FvxCorrelation->PutWindowTouch( static_cast<FVXCOMLib::WINDOW_TOUCH_TYPE>( 1 ) );
	}
	else
	{
		m_FvxCorrelation->PutWindowTouch( static_cast<FVXCOMLib::WINDOW_TOUCH_TYPE>( 0 ) );
	}

	// G[
	iStatus = 0;

	return iStatus;
}

// Q̓o^p^[ɂāAT[`s
// Ԓl  I = 0, ُI(p^[Ȃetc) = -1
int CXyangleDlg::Search( IFvSearchResultPtr pSearch_0, IFvSearchResultPtr pSearch_1 )
{
	int iStatus = -1;
	long lCount, lErr;
	CString GetCorrelationErrMesg;

	// p^[PT[`s
	try
	{
		m_FvxCorrelation->SetPattern( m_FvxPattern );
		m_FvxCorrelation->Execute( m_FvxImage, &lCount );
    
		if( 1 == lCount )
		{
			m_FvxCorrelation->GetResult( 0, pSearch_0 );

			// p^[QT[`s
			m_FvxCorrelation->SetPattern( m_FvxPattern2 );
			m_FvxCorrelation->Execute( m_FvxImage, &lCount );

			if( 1 == lCount )
			{
				m_FvxCorrelation->GetResult( 0, pSearch_1 );

				// p^[QƂԒl = 0
				iStatus = 0;
			}
			else
			{
				::AfxMessageBox( "p^[Q܂" );
			}
		}
		else
		{
			::AfxMessageBox( "p^[P܂" );
		}
	}
	catch( _com_error )
	{
		m_FvxCorrelation->GetErrReport( &lErr );
		switch( lErr )
		{
			case 0:
				GetCorrelationErrMesg = "G[";
			case 5001:
				GetCorrelationErrMesg = "p^݂Ă܂B";
			case 5005:
				GetCorrelationErrMesg = "p[^Ⴂ܂B";
			case 5006:
				GetCorrelationErrMesg = "^Ⴂ܂B";
			case 5007:
				GetCorrelationErrMesg = "p^摜̂߁Ao^ł܂B";
			case 5008:
				GetCorrelationErrMesg = "p^ƃ}XÑTCYvĂ܂B";
			case 5009:
				GetCorrelationErrMesg = "p[^NULLlw肳܂B";
			case 5010:
				GetCorrelationErrMesg = "̊mۂɎs܂B";
			case 5022:
				GetCorrelationErrMesg = "p^w肳Ă܂B";
			default:
				GetCorrelationErrMesg = "sȃG[";
		}

		::AfxMessageBox( GetCorrelationErrMesg );
	}

	return iStatus;
}


void CXyangleDlg::DrawPointMark( IFvPointPtr pPoint )
{
	IFvRectangle2Ptr pBox( __uuidof( FvRectangle ) );
	IFvLineSegmentPtr pLineSeg( __uuidof( FvLineSegment ) );

	double dX, dY;

	dX = pPoint->Getx();
	dY = pPoint->Gety();

	pBox->Putxs( dX - 3 );
	pBox->Putys( dY - 3 );
	pBox->Putxe( dX + 3 );
	pBox->Putye( dY + 3 );
	m_FvxDisplayEx->DrawData( 0, pBox );

	pLineSeg->Putxs( dX - 8 );
	pLineSeg->Putxe( dX + 8 );
	pLineSeg->Putys( dY );
	pLineSeg->Putye( dY );
	m_FvxDisplayEx->DrawData( 0, pLineSeg );

	pLineSeg->Putxs( dX );
	pLineSeg->Putxe( dX );
	pLineSeg->Putys( dY - 8 );
	pLineSeg->Putye( dY + 8 );
	m_FvxDisplayEx->DrawData( 0, pLineSeg );

}

// -΁`΂܂ŌvZł悤Atng
double CXyangleDlg::ArcTan( double dX, double dY )
{
	double iStatus = 0;

	if( dX > 0 )
	{
		iStatus = atan( dY / dX );
	}
	else
	{
		if( dY > 0 )
		{
			iStatus = PI - atan( dY / -dX ); 
		}
		else
		{
			iStatus = atan( -dY / -dX ) - PI;
		}
	}

	return iStatus;
}

void CXyangleDlg::OnSetStandard() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	IFvSearchResultPtr pSearch_0( __uuidof( FvSearchResult ) );
	IFvSearchResultPtr pSearch_1( __uuidof( FvSearchResult ) );
	IFvLinePtr pLine( __uuidof( FvLine ) );

	CString strResult;
	double dX_0, dY_0, dX_1, dY_1;

	m_FvxDisplayEx->ClearOverlay( 0 );

	// ep[^̓Kp
	if( -1 == ApplyChanges() ) return;

	if( 0 == Search( pSearch_0, pSearch_1 ) )
	{
		// ͈͂ŕ\
		m_FvxDisplayEx->PutPenColor( RGB(0, 0, 255) );
		m_FvxDisplayEx->DrawData( 0, m_ExeRegion );

		// T[`ʂ͐Ԃŕ\
		m_FvxDisplayEx->PutPenColor( RGB(255, 0, 0) );

		m_FvxDisplayEx->DrawData( 0, pSearch_0 );
		m_FvxDisplayEx->DrawData( 0, pSearch_1 );

		// Q̃T[`ʂ̒_ƁAxƂ̌p߂
		dX_0 = pSearch_0->Getx();
		dY_0 = pSearch_0->Gety();
		dX_1 = pSearch_1->Getx();
		dY_1 = pSearch_1->Gety();

		m_StandardPoint->Putx( ( dX_0 + dX_1 ) / 2 );
		m_StandardPoint->Puty( ( dY_0 + dY_1 ) / 2 );
		// px߂ۂɁAW͉Ɍƒl傫Ȃ邱ƂɒӂĂ
		// ̂߁A̒l͉EŐɂȂ܂B
		m_dStandardAngle = ArcTan( (dX_1 - dX_0), (dY_1 - dY_0) );

		m_FvxDisplayEx->PutPenColor( RGB(0, 0, 255) );
		DrawPointMark( m_StandardPoint );

		// FvxCalcDataR|[lg𗘗pāA
		// _ʂ钼̎߂
		m_FvxCalcData->CalcLine_TwoPoint( pSearch_0, pSearch_1 );
		m_FvxCalcData->CalcLine_GetResult( pLine );

		m_FvxDisplayEx->DrawData( 0, pLine );


		strResult.Format( "p^1W@( %.2f, %.2f )\r\np^2W@( %.2f, %.2f )\r\nw  %.2f\r\nx  %.2f\r\npx  %.2f\r\n",
						   pSearch_0->Getx(), pSearch_0->Gety(), pSearch_1->Getx(), pSearch_1->Gety(),
						   m_StandardPoint->Getx(), m_StandardPoint->Gety(), -m_dStandardAngle * 180 / PI/*ŐɂȂ悤\*/ );
		m_Result.SetWindowText( strResult );
	}

}

void CXyangleDlg::OnExecute() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	IFvSearchResultPtr pSearch_0( __uuidof( FvSearchResult ) );
	IFvSearchResultPtr pSearch_1( __uuidof( FvSearchResult ) );
	IFvLinePtr pLine( __uuidof( FvLine ) );
	IFvPointPtr pNowPoint( __uuidof( FvPoint ) );// Q̃p^[̃T[`ʂ̊_񂾐̒_
	double dNowAngle;// Q̃p^[̃T[`ʂ̊_񂾒̊px
	double dTime;// 
	double dDiffX, dDiffY;// Y
	double dDiffAngle;// P = WA
	double dX_0, dY_0, dX_1, dY_1;
	CString strResult, strTmp;

	m_FvxDisplayEx->ClearOverlay( -1 );

	// ep[^̓Kp
	if( -1 == ApplyChanges() ) return;

	// ԌvJn
	m_FvxPerformanceCounter->StartCount();

	// ͈͂ŕ\
	m_FvxDisplayEx->PutPenColor( RGB(0, 0, 255) );
	m_FvxDisplayEx->DrawData( 0, m_ExeRegion );

	if( 0 == Search( pSearch_0, pSearch_1 ) )
	{
		// T[`ʂ͐Ԃŕ\
		m_FvxDisplayEx->PutPenColor( RGB(255, 0, 0) );

		m_FvxDisplayEx->DrawData( 0, pSearch_0 );
		m_FvxDisplayEx->DrawData( 0, pSearch_1 );

		// Q̃T[`ʂ̒_ƁAxƂ̌p߂
		dX_0 = pSearch_0->Getx();
		dY_0 = pSearch_0->Gety();
		dX_1 = pSearch_1->Getx();
		dY_1 = pSearch_1->Gety();

		pNowPoint->Putx( (dX_0 + dX_1) / 2 ); 
		pNowPoint->Puty( (dY_0 + dY_1) / 2 ); 

		// px߂ۂɁAW͉Ɍƒl傫Ȃ邱ƂɒӂĂ
		// ̂߁A̒l͉EŐɂȂ܂B
		dNowAngle = ArcTan( (dX_1 - dX_0), (dY_1 - dY_0) );

		DrawPointMark( pNowPoint );

		m_FvxDisplayEx->PutPenColor( RGB(0, 0, 255) );
		// FvxCalcDataR|[lg𗘗pāA
		// _ʂ钼̎߂
		m_FvxCalcData->CalcLine_TwoPoint( pSearch_0, pSearch_1 );
		m_FvxCalcData->CalcLine_GetResult( pLine );
		m_FvxDisplayEx->DrawData( 0, pLine );


		// _Ԃŕ\
		m_FvxDisplayEx->PutPenColor( RGB(255, 0, 0) );
		DrawPointMark( m_StandardPoint );
		// 𔖂Ԃ̓_ŕ\
		m_FvxDisplayEx->PutPenColor( RGB(255, 192, 192) );
		m_FvxDisplayEx->PutPenStyle( DISPLAYEX_PenDot );

		// _: ( x1, y1 ) px: ƂƁA̎
		// - xsin + ycos + ( x1sin - y1cos ) = 0
        pLine->Puta( -sin(m_dStandardAngle) );
        pLine->Putb( cos(m_dStandardAngle) );
        pLine->Putc( (m_StandardPoint->Getx() * sin(m_dStandardAngle)) - (m_StandardPoint->Gety() * cos(m_dStandardAngle)) );
		m_FvxDisplayEx->DrawData( 0, pLine );

		// T[`ʂ̒_ʂAƕsȒ𔖂̓_ŕ\
		m_FvxDisplayEx->PutPenColor( RGB(192, 192, 255) );
		// Wa,b͊ƈꏏ
		pLine->Putc( (pNowPoint->Getx() * sin(m_dStandardAngle)) - (pNowPoint->Gety() * cos(m_dStandardAngle)) );
		m_FvxDisplayEx->DrawData( 0, pLine );
    
		// ̃X^Cɖ߂
		m_FvxDisplayEx->PutPenStyle( DISPLAYEX_PenSolid );


		// Ƃ̃YvZ
		dDiffX = ( pNowPoint->Getx() - m_StandardPoint->Getx() );
		dDiffY = ( pNowPoint->Gety() - m_StandardPoint->Gety() );
		dDiffAngle = ( m_dStandardAngle - dNowAngle );// Ő̒lɂȂ悤vZ

		strResult.Format( "Yw  %.2f\r\nYx  %.2f\r\nYpx  %-.2f\r\n",
						   dDiffX, dDiffY, dDiffAngle * 180 / PI );
	}

	// ԌvI
	m_FvxPerformanceCounter->StopCount( &dTime );

	strTmp.Format( "\r\n\r\n : %.2fmsec", dTime );
	strResult += strTmp;
	m_Result.SetWindowText( strResult );

}

void CXyangleDlg::OnExeRegion() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	long lOkCancel;
	double dXs, dYs, dXe, dYe;

	m_FvxROI->SetRectangle( m_ExeRegion );

	// FvxROIgď͈͑I_CAOo܂
	m_FvxROI->PutUsePoint( FALSE );
	m_FvxROI->MakeROIDialog( m_FvxImage, &lOkCancel );

	if( 1 == lOkCancel && 1 == m_FvxROI->GetCheckRectangle() )
	{
		m_FvxROI->GetRectangle( m_ExeRegion );

		// n_ƏI_tɂȂĂȂ`FbN܂
		// FvxROI͋`f[^ŁAEE̍Wʒu(xs > xe, ys > ye)
		// tɂȂĂꍇłAւ̂܂܌ʂԂ܂̂ŁAӂĂ

		dXs = m_ExeRegion->Getxs();
		dYs = m_ExeRegion->Getys();
		dXe = m_ExeRegion->Getxe();
		dYe = m_ExeRegion->Getye();

		if( dXe < dXs )
		{
			m_ExeRegion->Putxs( dXe );
			m_ExeRegion->Putxe( dXs );
		}

		if( dYe < dYs )
		{
			m_ExeRegion->Putys( dYe );
			m_ExeRegion->Putye( dYs );
		}
	}
}

void CXyangleDlg::SetPattern( int iPatternNum )
{
	IFvRectangle2Ptr pRect( __uuidof( FvRectangle ) );
	IFvPointPtr pPoint( __uuidof( FvPoint ) );

	long lOkCancel;
	double dXs, dYs, dXe, dYe;

	// o^̏`ݒ
	m_FvxROI->InitPoint();
	m_FvxROI->InitRectangle();
	pRect->Putxs( 100 );
	pRect->Putys( 100 );
	pRect->Putxe( 200 );
	pRect->Putye( 200 );
	m_FvxROI->SetRectangle( pRect );

	// FvxROIgď͈͑I_CAOo܂
	m_FvxROI->MakeROIDialog( m_FvxImage, &lOkCancel );

	if( 1 == lOkCancel && 1 == m_FvxROI->GetCheckRectangle() )
	{
		m_FvxROI->GetRectangle( pRect );

		// n_ƏI_tɂȂĂȂ`FbN܂
		// FvxROI͋`f[^ŁAEE̍Wʒu(xs > xe, ys > ye)
		// tɂȂĂꍇłAւ̂܂܌ʂԂ܂̂ŁAӂĂ

		dXs = pRect->Getxs();
		dYs = pRect->Getys();
		dXe = pRect->Getxe();
		dYe = pRect->Getye();

		if( dXe < dXs )
		{
			pRect->Putxs( dXe );
			pRect->Putxe( dXs );
		}

		if( dYe < dYs )
		{
			pRect->Putys( dYe );
			pRect->Putye( dYs );
		}

		if( 1 == m_FvxROI->GetCheckPoint() )
		{
			m_FvxROI->GetPoint( pPoint );
		}
		else
		{
			::AfxMessageBox( "p^[_w肳܂łB\np^[`̒S_Ƃēo^܂" );

			dXs = pRect->Getxs();
			dYs = pRect->Getys();
			dXe = pRect->Getxe();
			dYe = pRect->Getye();

			pPoint->Putx( (dXs + dXe) / 2 );
			pPoint->Puty( (dYs + dYe) / 2 );
		}

		switch( iPatternNum )
		{
			case 1:
				m_FvxPattern->MakePattern( m_FvxImage, pRect, pPoint );
				break;
			case 2:
				m_FvxPattern2->MakePattern( m_FvxImage, pRect, pPoint );
				break;
		}
	}

}

void CXyangleDlg::OnSetpattern1() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	SetPattern( 1 );
}

void CXyangleDlg::OnSetmask1() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	m_FvxPattern->DefMask( 100, 100 );

}

void CXyangleDlg::OnDisppattern1() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	m_FvxPattern->Disp( 100, 100 );

}

void CXyangleDlg::LoadPattern( int iPatternNum )
{
	// p^[t@C̊gq͓Ɍ߂Ă܂񂪁A
	// "pat"gp邱Ƃ𐄏܂

	// R_CAONX̐
	char szFilters[] = "ptn file(*.ptn)|*.ptn||";
	char szPtnFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName( GetModuleHandle(NULL), szPtnFilePath, _MAX_PATH );
	// _CAOɂăp^t@CI܂
	CFileDialog fdlg( TRUE, "ptn", NULL, OFN_PATHMUSTEXIST|OFN_HIDEREADONLY, szFilters, this );
	fdlg.m_ofn.lpstrInitialDir = szPtnFilePath;
	fdlg.m_ofn.lpstrTitle = "p^t@Cǂݍ";

	if( IDOK == fdlg.DoModal() )
	{
		try
		{
			switch( iPatternNum )
			{
				case 1:
					m_FvxPattern->PutLoadPattrenFileName( _bstr_t( fdlg.GetPathName() ) );
					m_FvxPattern->Load();
					break;
				case 2:
					m_FvxPattern2->PutLoadPattrenFileName( _bstr_t( fdlg.GetPathName() ) );
					m_FvxPattern2->Load();
					break;
			}
		}
		catch( _com_error )
		{
			::AfxMessageBox( "p^t@C̓Ǎ݂Ɏs܂B", MB_ICONWARNING | MB_OK );
			return;
		}
	}

}

void CXyangleDlg::OnLoadpattern1() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	LoadPattern( 1 );
}

void CXyangleDlg::SavePattern( int iPatternNum )
{
	// R_CAONX̐
	char szFilters[] = "ptn file(*.ptn)|*.ptn||";
	char szPtnFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName( GetModuleHandle(NULL), szPtnFilePath, _MAX_PATH );
	CFileDialog fdlg( FALSE, "ptn", NULL, OFN_PATHMUSTEXIST|OFN_HIDEREADONLY, szFilters, this );
	fdlg.m_ofn.lpstrInitialDir = szPtnFilePath;
	fdlg.m_ofn.lpstrTitle = "p^t@Cۑ";

	if( IDOK == fdlg.DoModal() )
	{
		try
		{
			switch( iPatternNum )
			{
				case 1:
					m_FvxPattern->PutSavePattrenFileName( _bstr_t( fdlg.GetPathName() ) );
					m_FvxPattern->Save();
					break;
				case 2:
					m_FvxPattern2->PutSavePattrenFileName( _bstr_t( fdlg.GetPathName() ) );
					m_FvxPattern2->Save();
					break;
			}
		}
		catch( _com_error )
		{
			::AfxMessageBox( "p^t@C̕ۑɎs܂B", MB_ICONWARNING | MB_OK );
			return;
		}
	}

}


void CXyangleDlg::OnSavepattern1() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	SavePattern( 1 );

}

void CXyangleDlg::OnSetpattern2() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	SetPattern( 2 );

}

void CXyangleDlg::OnSetmask2() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

	m_FvxPattern2->DefMask( 100, 100 );

}

void CXyangleDlg::OnDisppattern2() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

	m_FvxPattern2->Disp( 100, 100 );

}

void CXyangleDlg::OnLoadpattern2() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	LoadPattern( 2 );
}

void CXyangleDlg::OnSavepattern2() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	SavePattern( 2 );
}

void CXyangleDlg::OnLoadImage() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	// R_CAONX̐
	char szFilters[] = "bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName( GetModuleHandle(NULL), szIniFilePath, _MAX_PATH );
	// _CAOɂĉ摜t@CI܂
	CFileDialog fdlg( TRUE, "bmp", NULL, OFN_PATHMUSTEXIST|OFN_HIDEREADONLY, szFilters, this );
	fdlg.m_ofn.lpstrInitialDir = szIniFilePath;
	fdlg.m_ofn.lpstrTitle = "摜t@Cǂݍ";

	if( IDOK == fdlg.DoModal() )
	{
		try
		{
			// FileAccessR|[lgpăt@CImageɉ摜ǂݍ݂܂
			m_FvxFileAccess->PutFilePath( _bstr_t( fdlg.GetPathName() ) );
			m_FvxFileAccess->LoadBitmap( m_FvxImage );
		}
		catch( _com_error )
		{
			long lErr;
			CString cStr;

			// G[ԍ擾
			m_FvxFileAccess->GetErrReport( &lErr );
			cStr.Format( "Ǎ݂Ɏs܂Berr_no = %ld", lErr );
			::AfxMessageBox( cStr, MB_ICONWARNING | MB_OK );
			return;
		}
	}

	// 摜^Cv`FbN
	if( imageGray != m_FvxImage->GetImageType() )
	{
		::AfxMessageBox( "OC摜ł͂܂", MB_ICONWARNING | MB_OK );

        m_FvxImage->PutBitPerPixel( 8 );
        m_FvxImage->PutImageType( imageGray );
        m_FvxImage->PutImageWidth( 512 );
        m_FvxImage->PutImageHeight( 480 );
	}

	m_FvxDisplayEx->DrawImage( m_FvxImage );
}

void CXyangleDlg::OnSaveImage() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	// R_CAONX̐
	char szFilters[] = "bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName( GetModuleHandle(NULL), szIniFilePath, _MAX_PATH );
	CFileDialog fdlg( FALSE, "bmp", NULL, OFN_PATHMUSTEXIST|OFN_HIDEREADONLY, szFilters, this );
	fdlg.m_ofn.lpstrInitialDir = szIniFilePath;
	fdlg.m_ofn.lpstrTitle = "摜t@Cۑ";

	if( IDOK == fdlg.DoModal() )
	{
		try
		{
			m_FvxFileAccess->PutFilePath( _bstr_t( fdlg.GetPathName() ) );
			m_FvxFileAccess->SaveBitmap( m_FvxImage );
		}
		catch( _com_error )
		{
			long lngErr;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format( "ۑɎs܂Berr_no = %d", lngErr );
			::AfxMessageBox( cStr, MB_ICONWARNING | MB_OK );
			return;
		}
	}
}

void CXyangleDlg::OnDoSample() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	long lErr;
	CString cStr, cFilePath;
	TCHAR szIniFilePath[_MAX_PATH];


	::GetModuleFileName( GetModuleHandle(NULL), szIniFilePath, _MAX_PATH );

	cFilePath = szIniFilePath;
	cFilePath.Replace( "xyangle.exe", "sample1.bmp" );

	// }X^摜ǂݍ
	try
	{
		m_FvxFileAccess->PutFilePath( _bstr_t( cFilePath ) );
		m_FvxFileAccess->LoadBitmap( m_FvxImage );
	}
	catch( _com_error )
	{
		m_FvxFileAccess->GetErrReport( &lErr );

		cStr.Format( "sample1.bmpǂݍ߂܂ł" );
		::AfxMessageBox( cStr, MB_ICONWARNING | MB_OK );
		return;
	}

	m_FvxDisplayEx->ClearOverlay( -1 );
	m_FvxDisplayEx->DrawImage( m_FvxImage );
	::AfxMessageBox( "}X^摜ǂݍ", MB_ICONWARNING | MB_OK );
	cFilePath = szIniFilePath;
	cFilePath.Replace( "xyangle.exe", "sample1.pat" );

	// p^ǂݍ
	try
	{
		m_FvxPattern->PutLoadPattrenFileName( _bstr_t( cFilePath ) );
		m_FvxPattern->Load();
	}
	catch( _com_error )
	{
		m_FvxPattern->GetErrReport( &lErr );

		cStr.Format( "sample1.patǂݍ߂܂ł" );
		::AfxMessageBox( cStr, MB_ICONWARNING | MB_OK );
		return;
	}

	cFilePath = szIniFilePath;
	cFilePath.Replace( "xyangle.exe", "sample2.pat" );

	try
	{
		m_FvxPattern2->PutLoadPattrenFileName( _bstr_t( cFilePath ) );
		m_FvxPattern2->Load();
	}
	catch( _com_error )
	{
		m_FvxPattern2->GetErrReport( &lErr );

		cStr.Format( "sample2.patǂݍ߂܂ł" );
		::AfxMessageBox( cStr, MB_ICONWARNING | MB_OK );
		return;
	}


	// ʒu
	OnSetStandard();
	::AfxMessageBox( "", MB_ICONWARNING | MB_OK );

	cFilePath = szIniFilePath;
	cFilePath.Replace( "xyangle.exe", "sample2.bmp" );

	// 摜ǂݍ
	try
	{
		m_FvxFileAccess->PutFilePath( _bstr_t( cFilePath ) );
		m_FvxFileAccess->LoadBitmap( m_FvxImage );
	}
	catch( _com_error )
	{
		m_FvxFileAccess->GetErrReport( &lErr );

		cStr.Format( "sample2.bmpǂݍ߂܂ł" );
		::AfxMessageBox( cStr, MB_ICONWARNING | MB_OK );
		return;
	}

	m_FvxDisplayEx->ClearOverlay( -1 );
	m_FvxDisplayEx->DrawImage( m_FvxImage );
	::AfxMessageBox( "摜ǂݍ", MB_ICONWARNING | MB_OK );

	// s
	OnExecute();
	::AfxMessageBox( "Yvs", MB_ICONWARNING | MB_OK );

}

void CXyangleDlg::OnGrab() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	// 摜t@Cǂݍ݂ɂāA摜TCY
	// ύXĂ\邽߁AChangeImageSizes܂B
	// 摜TCYύX\ꍇ́AɈxsΖL܂B
	m_FvxVideo->ChangeImageSize( m_FvxImage );
	
	// 捞
	m_FvxVideo->GrabSync( m_FvxImage );

	// 荞񂾉摜ʂɕ\
	m_FvxDisplayEx->DrawImage( m_FvxImage );
}

void CXyangleDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	
	if( IsIconic() == 0 )
	{
		if( m_FvxDisplayEx != NULL )
		{

			CWnd *pwnd;
			CRect rect;

			pwnd = GetDlgItem( IDC_FVXDISPLAYEX1 );
			pwnd->GetWindowRect( rect );

			// XN[WNCAgWɕϊ
			ScreenToClient( rect );

			// FvxDisplayEx̃TCYύX
			pwnd->MoveWindow( rect.left , rect.top, cx - (rect.left + 20) , cy - (rect.top + 20) , TRUE );

		}
	}
}
